# This files handles the conversions between data formats

import copy
from kraEntry import kraEntry
from cocData import cocData

#
#  Transforms a cocoon 0.4 data file into a kraken 0.5 entry object
#
def cocData_to_kraEntry(cd):
    kd = kraEntry()
    kd.title = cd.title
    kd.description = cd.description
    kd.date = cd.date
    kd.localFileNames = [cd.fileName]
    kd.originalURIs = [cd.originalURL]
    kd.size = cd.size
    # fixme: clone
    kd.keywords = copy.deepcopy(cd.categories)
    return kd    

#
#  Transforms a kraken 0.5 entry object into a cocoon 0.4 cocoon file
#
def kraEntry_to_cocData(ke):
    cd = cocData()
    cd.singlefile = 1
    if len(ke.localFileNames) >= 1:
        cd.fileName = ke.localFileNames[0]
    else:
        cd.fileName = ""
    if len(ke.originalURIs) >= 1:
        cd.originalURL = ke.originalURIs[0]
    else:
        cd.originalURL = ""
    cd.size = ke.size
    cd.date = ke.date
    # fixme: clone
    cd.categories = copy.deepcopy(ke.keywords)
    cd.title = ke.title
    cd.description = ke.description
    return cd
