import pickle
import os
import os.path
import string
from kraConstants import kraConstants
from cocData import cocData, loadCocData
from kraEntry import kraEntry, loadKraEntry
from kraLog import log
import kraLog
from kraConvert import *


class kraMetaData:

    def __init__(self):
       self.entries = [] # the loaded data
       self.keywords = []
       
     
    def load(self, config, runtime):
        log("Generating the metadata...")
        for a in config.krakenDirs:
            self.__loadOneDir(a, config, runtime)        
        log("Done.")
    
    def __loadOneDir(self, directory, config, runtime):
        # FIXME: import problems checkValidCocoon(config, runtime)
        for x in os.listdir(directory):
           if not os.path.isdir(directory + "/" + x):
               continue
           # try if the kraken file is there 
           entry = loadKraEntry(config, directory + "/" + x)
           if (entry == None):
              cocoonData = loadCocData(config, directory + "/" + x)
              if (cocoonData == None):
                  log("Directory " + directory + "/" + x + " does not seem to contain a kraken entry", kraLog.WARNING)
                  continue
              log("Directory " + x + " contains an old style cocoon 0.4 entry", kraLog.WARNING)
              entry = cocData_to_kraEntry(cocoonData)
              # and now writing out the new one
              print "Writing the RDF format"
              entry.writeRDF(directory + "/" + x + "/"+kraConstants.FILENAME_ENTRY_RDF)
              print "Done"
           # FIXME: this is for converting older files.           
           # entry.directoryName = x                    
           # entry.writeRDF(directory + x + "/"+kraConstants.FILENAME_ENTRY_RDF)
           # End FIXME
           entry.krakenDirName = directory
           self.entries.append(entry)
           self.__updateKeywords(entry)
        print "Keywords: " + str(self.keywords)
               

    def __updateKeywords(self, entry):
        for a in entry.keywords:
           b = string.strip(a)
           if b not in self.keywords:
              self.keywords.append(b) # needed because of some old errors

    def __str__(self):
        x = "Summary of the kraken:"
        x = x + "\n\tThere are " + str(len(self.entries)) + " entries."
        x = x + "\n\tKeywords: " + str(self.keywords)
        return x                        

def generateCache(config, runtime):
    filename = os.path.expanduser(kraConstants.METADATA_FILE)
    temp = kraMetaData()
    temp.load(config, runtime)
    # this is the cache creation stuff
    # FIXME: there was some problem here, some weird serialization problem
    # pickle expression can not pickle thread.lock    
    __writeToFile(temp, filename)
    return temp
           
def loadMetaData(config, runtime):
  filename = os.path.expanduser(kraConstants.METADATA_FILE)
  if runtime.forceRegenerateCache:
      return generateCache(config, runtime)
  try:    
    FILE = open(filename)
    temp = pickle.load(FILE)
    FILE.close()
    # FIXME: check if what is in the file, is metadata
    return temp
  except:
    print "Can not open metadata file " + filename
    return generateCache(config, runtime)
    
def __writeToFile(metadata, filename):
   filename = os.path.expanduser(filename)
   FILE = open(filename, "w")
   pickle.dump(metadata, FILE)
   FILE.close()          
    
