import time
import os.path
# from cocConstants import cocConstants
from kraConstants import kraConstants        
        
# ***********************************************************
#  Generate web page
# ***********************************************************

def generateText(config, runtime, metadata): 
        temp = "Number of entries = " + str(len(metadata.entries)) + "\n"        
        for a in metadata.entries:
            temp += a.title + "\t" + a.label + "\n"
        return temp

# ***********************************************************
#  Generate web page
# ***********************************************************

def generateHtml(config, runtime, metadata):
       temp = "";
       temp += "<html>\n"
       temp += "<head>\n"
       # Fixme: we will need this
       temp += '<link HREF="' + kraConstants.DEFAULT_CSS_FILE + '" REL="STYLESHEET" LANG="en.us">'
       temp += "</head>\n"
       
       temp += __generateHeader(config, runtime, metadata)
       
       temp +='<table class=' + kraConstants.CSS_TABLE + ' COLS=2 WIDTH="100%">\n'
       odd = 1
       for a in metadata.entries:
          if a.title == "": 
              a.title = "Unknown title"
          if a.description == "": 
              a.description = "No description"
          # handling the different color of odd and even rows
          if odd:
              csscell = kraConstants.CSS_CELL_ODD
              odd = 0
          else:
              csscell = kraConstants.CSS_CELL_EVEN
              odd = 1
          # create the row
          temp += "<tr>\n"
          # first cell: title, description
          temp += '<td class=' + csscell + '>'
          for x in a.localFileNames:
             temp += '<a href="file:///' + a.krakenDirName + "/" + a.directoryName + "/" + x + '">' +  a.title + "</a><br/>\n"
          if len(a.localFileNames) == 0:
             temp += '<a href="file:///' + a.krakenDirName + "/" + a.directoryName + "/" + '">' + a.title  + "</a>\n"              
          temp += "<p class=" + kraConstants.CSS_DESCRIPTION+">"+ a.description + "</p>\n"
          temp += __generateMetaData(config, runtime, a)
          temp += "</td>\n"
          # second cell: original URL, date
          temp += '<td class=' + csscell + '>\n'
          for x in a.originalURIs:
             temp += "<p class=originalUrl>"+ x + "</p>\n"
          temp += "<p class=date>"+ "Date:" + time.strftime(kraConstants.HTML_DATE_FORMAT, a.date) + "</p>\n"
          temp += "<p class=" + kraConstants.CSS_CATEGORIES+">"+ "Categories: "          
          for cats in a.keywords:
              temp += cats + ", "
          temp = temp[:-2]    
          temp += "</p>\n"          
          temp += "<p class=" + kraConstants.CSS_COCOON_POS+">"+ "Coccon: " + a.directoryName + "</p>\n"          
          temp += "</td>\n"
          # end of row
          temp += "</tr>\n"
       temp += "</table>\n"
       return temp

def __generateHeader(config, runtime, metadata):
    temp = ""
    temp +='<p><b>Generated on:</b>' + time.strftime("%a, %d %b %Y %H:%M:%S +0000", time.localtime())
    # fixme write out the query
    temp +="<p><b>Filter all keywords:</b> " + runtime.selectKeywordsAll
    temp +="<p><b>Filter any keywords:</b> " + runtime.selectKeywordsAny
    
    return temp

def __generateMetaData(config, runtime, entry):
    temp = ""
    metadataDir = entry.krakenDirName + "/" + entry.directoryName + "/" + "Metadata" + "/"
    temp += __addMetaDataLink(metadataDir, "bibtex.bib", "[BibTeX]")
    temp += __addMetaDataLink(metadataDir, "summary.txt", "[Summary]")
    temp += __addMetaDataLink(metadataDir, "quotes.txt", "[Quotes]")
    return temp
    
def __addMetaDataLink(metadataDir, mdFile, mdLabel):
    # FIXME: this is for Windows
    if os.path.exists(metadataDir + mdFile):
        return '<a href="file:///' + metadataDir + "/" + mdFile + '">' +  mdLabel + "</a>\n"
    else:
        return ""

