from kraMetaData import kraMetaData
import copy
import string

ALL = 1
ANY = 2

def filterMetaData(metadata, runtime):
    md = metadata    
    if runtime.selectKeywordsAll != "":
        s = string.split(runtime.selectKeywordsAll, ",")
        md = filterKeywords(md, s, ALL)
    if runtime.selectKeywordsAny != "":
        print "Any filter"
        s = string.split(runtime.selectKeywordsAny, ",")
        md = filterKeywords(md, s, ALL)
    return md        

def filterKeywords(metadata, keywords, filtertype):
    temp = kraMetaData()
    temp.keywords = copy.deepcopy(metadata.keywords)
    for a in metadata.entries:
        if matches(a, filtertype, keywords):
            print "Appending" + str(a)
            temp.entries.append(copy.deepcopy(a))
    return temp
    
def matches(entry, filtertype, keywords):
    if filtertype == ANY:
        return matchesAny(entry, keywords)
    if filtertype == ALL:
        return matchesAny(entry, keywords)
        
def matchesAny(entry, keywords):
    for a in keywords:
        if a in entry.keywords:
            return 1
    return 0
        
def matchesAll(entry, keywords):
    for a in keywords:
        if not (a in entry.keywords):
            return 0
    return 1
        
