# **************************************************
#
#  The configuration class
#
# **************************************************

import string
import time
import os
import kraUtils
from kraMetaData import loadMetaData

# constants for commands

class kraRuntime:
    
    NOTHING_TO_DO        = 0
    CREATE_ENTRY         = 1
    ANNOTATE_ENTRY       = 2
    GENERATE_TEXT        = 3
    GENERATE_HTML        = 4
    ADD_DIRECTORY        = 5
    REMOVE_DIRECTORY     = 6
    SHOW_CONFIGURATION   = 7
    SHOW_SUMMARY         = 8
    BACKUP_KRAKEN        = 9
    EMBRACE_ENTRIES      = 10
    
    def __init__(self):
        # command line arguments
        self.arguments = ""
        # command line options
        self.inputFile = ""
        self.inputHttp = ""
        self.outputFile = ""
        self.recursive = 0
        self.title = ""
        self.description = ""
        self.interactive = 0
        self.forceRegenerateCache = 0
        
        # FIXME: change to keywords
        self.tmpKeywords = ""
        self.keywords = []
        self.tmpDate = ""
        self.date = time.localtime()

        # the command
        self.theCommand = self.NOTHING_TO_DO
        
        # runtime stuff
        self.entryDir = ""
        self.annotateEntry = ""
        self.directoryToAdd = ""
        self.directoryToRemove = ""
        
        # queries
        self.selectKeywordsAll = ""
        self.selectKeywordsAny = ""                
        
    def interactiveRead(self, config):
        metadata = loadMetaData(config, self)        
        self.title = kraUtils.inputWithDefault("title", self.title)
        self.description = kraUtils.inputWithDefault("description", self.description)
        self.keywords = kraUtils.inputSequenceWithDefault("Keywords", self.keywords, metadata.keywords)
        
        
    # experiments in printing   
    def __str__(self):
       x = "Config:\n"
       for a in self.__class__.__dict__.keys():
           if a[0:2] != "__":
               x = x + "\t" + a + " = " + str(self.__class__.__dict__[a]) + "\n"
       return x 
    __repr__ = __str__  
